﻿using AsReaderP31N;
using AsReaderP31N_Demo_Tool;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Configuration;
using System.IO;
using System.IO.Ports;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace AsReaderP51N_Demo_Tool
{
    public partial class AsReaderP31N_Demo_Tool : Form
    {
        private int total_time = 0;//The total time.
        int singluationCount = 0;
        volatile bool m_bInventory = false;
        bool isConnected = false;
        int selectedIndex = 0;
        string connType = "";

        private Hashtable mTagHashTable = new Hashtable();
        private AsReader.InventoryResult mReadTag;
        private delegate void ProcessDelegate();

        public AsReaderP31N_Demo_Tool()
        {
            InitializeComponent();
#if DEBUG
            StaticIP_Text.Text = "192.168.10.122";
            Gateway_Text.Text = "192.168.10.1";
            Dns_Text.Text = "192.168.10.1";
            SubnetMask_Text.Text = "255.255.255.0";
#endif
        }

        /// <summary>
        /// UDP Search
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSearch_Click(object sender, EventArgs e)
        {
            btnSearch.Enabled = false;
            Cursor.Current = Cursors.WaitCursor;
            cmbTCPIPAddr.Items.Clear();
            cmbTCPIPAddr.Text = "";

            List<string> ipList = new List<string>();
            Device.GetDeviceIPInformation(ref ipList);

            if (ipList != null && ipList.Count > 0)
            {
                foreach (string item in ipList)
                {
                    if (item != "") cmbTCPIPAddr.Items.Add(item);
                }

            }
            if (cmbTCPIPAddr.Items.Count > 0)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Search success." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
            else {

                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " IP address not found." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }

            btnSearch.Enabled = true;
        }

        private void initForms()
        {
            SetCombolList();
            string[] vcpPort = GetPortList();
            int i = 0;
            //有限判断是否开通端口模式
            if (vcpPort.Length > 0)
            {
                for (i = 0; i < vcpPort.Length; i++)
                {
                    this.ComPort.Items.Add(vcpPort[i]);
                }
                if (i > 0)
                    this.ComPort.SelectedIndex = 0;
            }
        }

        /// <summary>
        /// VCP disconnect
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnVcpDisconnect_Click(object sender, EventArgs e)
        {
            if (m_bInventory) StopInventory();
            UInt32 error = 0;
            error = Device.DisConnect();

            if (error == 1)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " DisConnect failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
            if (error == 0)
            {
                this.ComPort.Enabled = true;
                this.txtBaudRate.Enabled = true;
                this.Connect.Enabled = true;
                this.button5.Enabled = true;
                this.button2.Enabled = false;
                isConnected = false;
            }
            this.ControlsEnabled();
        }

        /// <summary>
        /// VCP Connect
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnVcpConnect_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;
            uint error = 0;
            isConnected = false;
            if (ComPort.Text.Length > 0)
            {
                string com_name = this.ComPort.SelectedItem.ToString();
                try
                {
                    error = Device.ConnectWithVcp(com_name);
                }
                catch (Exception ex)
                {
                    Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " " + ex.Message + Environment.NewLine);
                    Devmes.ScrollToCaret();
                    return;
                }

                if (error != 0)
                {
                    Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Connect failed." + Environment.NewLine);
                    Devmes.ScrollToCaret();
                    return;
                }
            }
            else
            {
                Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " COM port is not exist,please check it." + Environment.NewLine);
                Devmes.ScrollToCaret();
                return;
            }
            Task.Run(() =>
            {
                this.BeginInvoke(new Action(() =>
                {
                    btnGetRegion_Click(btnGetRegion, e);
                }));
                Thread.Sleep(200);
                this.BeginInvoke(new Action(() =>
                {
                    button1_Click_1(button1, e);
                }));
                Thread.Sleep(200);
                this.BeginInvoke(new Action(() =>
                {
                    button6_Click(null, null);
                }));
            });

            if (error == 0 && getRegionErr && getSessionErr && getCollisionErr && getPowerErr && getReadTimeErr && getIdleTimeErr)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Connect failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                if (error == 0) Device.DisConnect();
                return;
            }
            isConnected = true;
            connType = "VCP";
            this.ControlsEnabled();
        }

        private void Write_Epc_Click(object sender, EventArgs e)
        {
            //input check
            string needMsg = "";
            if (txtEpc.Text == "") needMsg += DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " [WARNING]Please input EPC." + Environment.NewLine;
            if (text_off.Text == "") needMsg += DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " [WARNING]Please input start address." + Environment.NewLine;
            if (needMsg != "")
            {
                this.Devmes.AppendText(needMsg);
                this.Devmes.ScrollToCaret();
                return;
            }
            //handle
            UInt32 error = 0;
            string Epc_string = this.txtEpc.Text.Replace(" ", "").Replace("0x", "");

            if (Epc_string.Length % 2 != 0)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Please input correct epc." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                return;
            }
            byte[] yu = { };
            yu = HexStringToByteArray(Epc_string);
            //Epc_string1 选中的要被覆盖的标签的值
            string Epc_string1 = this.txtSelectedTag.Text.Replace(" ", "").Replace("0x", "");

            if (Epc_string1.Length % 2 != 0)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Please input correct epc of selected." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                return;
            }
            byte[] ren = { };
            ren = HexStringToByteArray(Epc_string1);

            error = Device.WriteMemory(
                SELSERVED.Checked ? Types.MemBankType.MEM_RESERVED : SELEPC.Checked ? Types.MemBankType.MEM_EPC : SELTID.Checked ? Types.MemBankType.MEM_TID : SELUSER.Checked ? Types.MemBankType.MEM_USER : 0,
                Convert.ToUInt32(text_off.Text),
                Convert.ToUInt32(ReadPassward.Text == "" ? "0" : ReadPassward.Text, 16), yu, ren);

            if (error == 1)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Write Tag command sent failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
        }

        static byte[] HexStringToByteArray(string s)
        {
            s = s.Replace(" ", "").Replace("0x", "");
            byte[] buffer = new byte[s.Length / 2];
            for (int i = 0; i < s.Length; i += 2)
                buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
            return buffer;
        }

        private void ReadTag_Click(object sender, EventArgs e)
        {
            UInt32 error = 0;
            Convert.ToUInt32(text_off.Text);
            string Epc_string = this.txtSelectedTag.Text.Replace(" ", "").Replace("0x", "");

            //input value check
            StringBuilder sb = new StringBuilder();
            if (Epc_string.Length % 2 != 0) sb.AppendLine(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " [WARNING]Please input correct epc of selected.");
            if (text_off.Text == "") sb.AppendLine(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " [WARNING]Please input start address.");
            if (ReadLenth.Text == "") sb.AppendLine(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " [WARNING]Please input length.");
            if (sb.ToString().Length > 0)
            {
                this.Devmes.AppendText(sb.ToString());
                this.Devmes.ScrollToCaret();
                return;
            }

            byte[] yu = { };
            yu = HexStringToByteArray(Epc_string);
            error = Device.ReadMemory(
                SELSERVED.Checked ? Types.MemBankType.MEM_RESERVED : SELEPC.Checked ? Types.MemBankType.MEM_EPC : SELTID.Checked ? Types.MemBankType.MEM_TID : SELUSER.Checked ? Types.MemBankType.MEM_USER : 0,
                Convert.ToUInt32(text_off.Text),
                Convert.ToUInt32(ReadLenth.Text),
                Convert.ToUInt32(ReadPassward.Text == "" ? "0" : ReadPassward.Text, 16), yu);

            if (error == 1)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Read Tag command sent failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
        }

        private void btnSelectMask_Click(object sender, EventArgs e)
        {
            UInt32 error = 0;

            string Epc_string = this.txtSelectedTag.Text.Replace(" ", "").Replace("0x", "");
            byte[] yu = { };
            if (Epc_string.Length % 2 != 0)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Please input correct epc of selected." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                return;
            }
            yu = HexStringToByteArray(Epc_string);

            error = Device.SetSelectMask(
                SELSERVED.Checked ? Types.MemBankType.MEM_RESERVED : SELTID.Checked ? Types.MemBankType.MEM_TID : SELEPC.Checked ? Types.MemBankType.MEM_EPC : SELUSER.Checked ? Types.MemBankType.MEM_USER : 0,
                (Types.TargetType)cmbTarget.SelectedValue,
                (Types.ActionType)cmbAction.SelectedValue,
                Convert.ToUInt32(SelOffset.Text, 16),
                yu);

            if (error == 1)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Select Tag command sent failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
        }

        /// <summary>
        /// TCP Connect
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button5_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;

            if (cmbTCPIPAddr.Text == "")
            {
                Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Please input IP address." + Environment.NewLine);
                Devmes.ScrollToCaret();
                return;
            }

            this.button5.Enabled = false;
            UInt32 error = Device.ConnectWithTcp(cmbTCPIPAddr.Text , TcpPort.Text);
            if (error == 0)
            {
                Task.Run(() =>
                {
                    this.BeginInvoke(new Action(() =>
                    {
                        btnGetRegion_Click(btnGetRegion, e);
                    }));
                    Thread.Sleep(200);
                    this.BeginInvoke(new Action(() =>
                    {
                        button1_Click_1(button1, e);
                    }));
                });
            }
            if (error == 1)
            {
                this.button5.Enabled = true;
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Connect with TCP failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                return;
            }
            if (error == 0 && getRegionErr && getSessionErr && getCollisionErr && getPowerErr && getReadTimeErr && getIdleTimeErr)
            {
                this.button5.Enabled = true;
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Connect with TCP failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                if (error == 0) Device.DisConnect();
                return;
            }
            connType = "TCP";
            isConnected = true;
            this.ControlsEnabled();
        }

        /// <summary>
        /// TCP disconnect
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnTcpDiscon_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;
            StopInventory();
            UInt32 error = 0;
            error = Device.DisConnect();

            if (error == 0)
            {
                isConnected = false;
            }
            this.ControlsEnabled();
        }
        
        /// <summary>
        /// kill tag
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button7_Click(object sender, EventArgs e)
        {
            string Epc_string = txtSelectedTag.Text.Replace(" ", "").Replace("0x", "");
            byte[] yu = { };

            if (Epc_string.Length % 2 != 0)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Please input correct epc of selected." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                return;
            }
            yu = HexStringToByteArray(Epc_string);
            UInt32 error = Device.Kill(Convert.ToUInt32(ReadPassward.Text == "" ? "0" : ReadPassward.Text, 16), yu);

            if (error == 1)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Kill Tag command sent failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
        }

        /// <summary>
        /// set ANT power
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSetPowerWithANT_Click(object sender, EventArgs e)
        {
            UInt32 error = 0;
            if (!CheckPowersWithRegionType())
            {
                return;
            }
            error = Device.SetTxPower(
                txtPower1.Text == "" ? 0 : Convert.ToUInt32(txtPower1.Text),
                txtPower2.Text == "" ? 0 : Convert.ToUInt32(txtPower2.Text),
                txtPower3.Text == "" ? 0 : Convert.ToUInt32(txtPower3.Text),
                txtPower4.Text == "" ? 0 : Convert.ToUInt32(txtPower4.Text),
                txtPower5.Text == "" ? 0 : Convert.ToUInt32(txtPower5.Text),
                txtPower6.Text == "" ? 0 : Convert.ToUInt32(txtPower6.Text),
                txtPower7.Text == "" ? 0 : Convert.ToUInt32(txtPower7.Text),
                txtPower8.Text == "" ? 0 : Convert.ToUInt32(txtPower8.Text)
                );
            if (error == 1) {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Set Power command sent failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
        }
        private bool CheckPowersWithRegionType()
        {
            if (CurrentRegionType == Types.RegionType.REGION_JAPAN)
            {
                if (Convert.ToUInt32(txtPower1.Text == "" ? "0" : txtPower1.Text) > 23 ||
                    Convert.ToUInt32(txtPower2.Text == "" ? "0" : txtPower2.Text) > 23 ||
                    Convert.ToUInt32(txtPower3.Text == "" ? "0" : txtPower3.Text) > 23 ||
                    Convert.ToUInt32(txtPower4.Text == "" ? "0" : txtPower4.Text) > 23 ||
                    Convert.ToUInt32(txtPower5.Text == "" ? "0" : txtPower5.Text) > 23 ||
                    Convert.ToUInt32(txtPower6.Text == "" ? "0" : txtPower6.Text) > 23 ||
                    Convert.ToUInt32(txtPower7.Text == "" ? "0" : txtPower7.Text) > 23 ||
                    Convert.ToUInt32(txtPower8.Text == "" ? "0" : txtPower8.Text) > 23)
                {
                    this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Please input correct antenna powers(Japan:13~23dbm)." + Environment.NewLine);
                    this.Devmes.ScrollToCaret();
                    return false;
                }
            }
            return true;
        }
        bool getPowerErr = false;
        private void GetPower_Click(object sender, EventArgs e)
        {
            UInt32 power1 = 0;
            UInt32 power2 = 0;
            UInt32 power3 = 0;
            UInt32 power4 = 0;
            UInt32 power5 = 0;
            UInt32 power6 = 0;
            UInt32 power7 = 0;
            UInt32 power8 = 0;
            UInt32 error = 0;

            error = Device.GetTxPower(ref power1, ref power2, ref power3, ref power4, ref power5, ref power6, ref power7, ref power8);
            if (error == 0)
            {
                txtPower1.Text = (CurrentRegionType == Types.RegionType.REGION_JAPAN && power1 > 23 ? 23 : power1).ToString();
                txtPower2.Text = (CurrentRegionType == Types.RegionType.REGION_JAPAN && power2 > 23 ? 23 : power2).ToString();
                txtPower3.Text = (CurrentRegionType == Types.RegionType.REGION_JAPAN && power3 > 23 ? 23 : power3).ToString();
                txtPower4.Text = (CurrentRegionType == Types.RegionType.REGION_JAPAN && power4 > 23 ? 23 : power4).ToString();
                txtPower5.Text = (CurrentRegionType == Types.RegionType.REGION_JAPAN && power5 > 23 ? 23 : power5).ToString();
                txtPower6.Text = (CurrentRegionType == Types.RegionType.REGION_JAPAN && power6 > 23 ? 23 : power6).ToString();
                txtPower7.Text = (CurrentRegionType == Types.RegionType.REGION_JAPAN && power7 > 23 ? 23 : power7).ToString();
                txtPower8.Text = (CurrentRegionType == Types.RegionType.REGION_JAPAN && power8 > 23 ? 23 : power8).ToString();
                getPowerErr = false;
                if (CurrentRegionType == Types.RegionType.REGION_JAPAN &&
                    (power1 > 23 || power2 > 23 || power3 > 23 || power4 > 23 || power5 > 23 || power6 > 23 || power7 > 23 || power8 > 23)) {
                    btnSetPowerWithANT_Click(null, null);
                }
            }
            if (error == 1)
            {
                txtPower1.Text = "";
                txtPower2.Text = "";
                txtPower3.Text = "";
                txtPower4.Text = "";
                txtPower5.Text = "";
                txtPower6.Text = "";
                txtPower7.Text = "";
                txtPower8.Text = "";
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Get Power command sent failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                getPowerErr = true;
            }
        }

        private void Clear_Click(object sender, EventArgs e)
        {
            total_time = System.Environment.TickCount;
            ClearTableData();
        }

        private void SetSession_Click(object sender, EventArgs e)
        {
            UInt32 error = 0;
            //session范围：0~3
            error = Device.SetSession((Types.SessionType)cmbSession.SelectedValue);

            if (error == 1)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Set Session command sent failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
        }

        bool getSessionErr = false;
        private void GetSession_Click(object sender, EventArgs e)
        {
            Types.SessionType sessionType = 0;
            UInt32 error = 0;
            error = Device.GetSession(ref sessionType);
            if (error == 0) {
                getSessionErr = false;
                cmbSession.SelectedValue = Convert.ToInt32(sessionType);
            }

            if (error == 1)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Get Session command sent failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                getSessionErr = true;
            }
        }

        /// <summary>
        /// set region
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSetRegion_Click(object sender, EventArgs e)
        {
            UInt32 error = 0;
            Types.RegionType regionType = (Types.RegionType)cmbRegion.SelectedValue;
            error = Device.SetRegion(regionType);

            if (error == 1)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Set Region command sent failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
            else
            {
                string maxPower = Device.getMaxPowerByRegion(regionType);
                if (maxPower != "") {
                    txtPower1.Text = txtPower2.Text = txtPower3.Text = txtPower4.Text = txtPower5.Text = txtPower6.Text = txtPower7.Text = txtPower8.Text = maxPower;
                    Device.SetTxPower(
                        Convert.ToUInt32(txtPower1.Text),
                        Convert.ToUInt32(txtPower2.Text),
                        Convert.ToUInt32(txtPower3.Text),
                        Convert.ToUInt32(txtPower4.Text),
                        Convert.ToUInt32(txtPower5.Text),
                        Convert.ToUInt32(txtPower6.Text),
                        Convert.ToUInt32(txtPower7.Text),
                        Convert.ToUInt32(txtPower8.Text)
                    );
                    Thread.Sleep(200);
                }
                btnGetRegion_Click(null, null);
            }
        }

        bool getRegionErr = false;
        Types.RegionType CurrentRegionType;
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnGetRegion_Click(object sender, EventArgs e)
        {
            CurrentRegionType = 0;
            Types.RegionType regionType = 0;
            UInt32 error = 0;
            error = Device.GetRegion(ref regionType);
            if (error == 0)
            {
                cmbRegion.SelectedValue = Convert.ToInt32(regionType);
                CurrentRegionType = regionType;

                switch (regionType)
                {
                    case Types.RegionType.REGION_CHINA2:
                        this.cmbChannel.DataSource = Device.getComboxList(typeof(Types.ChinaChannelType));
                        break;

                    case Types.RegionType.REGION_JAPAN:
                        this.cmbChannel.DataSource = Device.getComboxList(typeof(Types.JPChannelType));
                        break;


                    case Types.RegionType.REGION_BRAZIL:
                        this.cmbChannel.DataSource = Device.getComboxList(typeof(Types.BrazilChannelType));
                        break;

                    case Types.RegionType.REGION_EUROPE:
                        this.cmbChannel.DataSource = Device.getComboxList(typeof(Types.EuropeChannelType));
                        break;

                    case Types.RegionType.REGION_US:
                    case Types.RegionType.REGION_US_NARROW:
                        this.cmbChannel.DataSource = Device.getComboxList(typeof(Types.USChannelType));
                        break;
                }
                this.cmbChannel.DisplayMember = "name";
                this.cmbChannel.ValueMember = "value";

                Task.Run(() =>
                {
                    this.BeginInvoke(new Action(() =>
                    {
                        GetSession_Click(GetSession, e);
                    }));
                    Thread.Sleep(200);
                    this.BeginInvoke(new Action(() =>
                    {
                        btnGetCollision_Click(btnGetCollision, e);
                    }));
                    Thread.Sleep(200);
                    this.BeginInvoke(new Action(() =>
                    {
                        GetPower_Click(GetPower, e);
                    }));
                    Thread.Sleep(200);
                    this.BeginInvoke(new Action(() =>
                    {
                        btnGetReadTime_Click(btnGetReadTime, e);
                    }));
                    Thread.Sleep(200);
                    this.BeginInvoke(new Action(() =>
                    {
                        btnGetIdleTime_Click(button11, e);
                    }));
                    Thread.Sleep(200);
                    this.BeginInvoke(new Action(() =>
                    {
                        btnGetChannel_Click(btnGetChannel, e);
                    }));
                });
                getRegionErr = false;
            }

            if (error == 1)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Get Region command sent failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                getRegionErr = true;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void cbAnt_CheckedChanged(object sender, EventArgs e)
        {
            //gbInventoryType.Enabled = !(cbAnt1.Checked || cbAnt2.Checked || cbAnt3.Checked || cbAnt4.Checked || cbAnt5.Checked || cbAnt6.Checked || cbAnt7.Checked || cbAnt8.Checked);
        }

        /// <summary>
        /// start inventory click
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void startInventory_Click(object sender, EventArgs e)
        {
            UInt32 error = 0;
            //string msg = "";
            //if (gbAnt.Enabled && gbInventoryType.Enabled)
            //{
            //    msg = DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Please select inventory type.";
            //    this.Devmes.AppendText(msg + Environment.NewLine);
            //    this.Devmes.ScrollToCaret();
            //    return;
            //}
            this.StartInventory.Enabled = false;
            if (m_bInventory)
            {
                error = Device.StopInventory();
                if (error != 0)
                {
                    this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Stop Inventory command sent failed." + Environment.NewLine);
                    this.Devmes.ScrollToCaret();
                    this.StartInventory.Enabled = true;
                    return;
                }
                m_bInventory = false;
                readTimer.Enabled = false;
                this.StartInventory.Text = "Start";
            }
            else
            {
                error = StartInventoryByTypes();
                if (error != 0)
                {
                    this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Start Inventory By Types command sent failed." + Environment.NewLine);
                    this.Devmes.ScrollToCaret();
                    this.StartInventory.Enabled = true;
                    return;
                }

                total_time = System.Environment.TickCount;
                ClearTableData();

                this.StartInventory.Text = "Stop";
                m_bInventory = true;
                readTimer.Enabled = true;
            }
            this.StartInventory.Enabled = true;
        }

        private void AsReaderBoxP31N_Demo_Tool_Load(object sender, EventArgs e)
        {
            this.initForms();
            this.ControlsEnabled();
            Device.callBackResultTagData = ShowTagData;
            Device.callBackResultError = ShowErrorMsg;
            Device.callBackResultSuccess = ShowSuccessMsg;
        }
        /// <summary>
        /// 扫描列表行选中时，将当前的标签内容放置到access tag的tab控件中
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void DatalistView_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (this.DatalistView.SelectedItems.Count > 0)
            {
                ListViewItem row = this.DatalistView.SelectedItems[0];
                if (row != null && row.SubItems[2] != null && row.SubItems[2].Text != null)
                {
                    txtSelectedTag.Text = row.SubItems[2].Text;
                    selectedIndex = this.DatalistView.SelectedItems[0].Index;
                }
            }
        }

        private void SelOffset_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789ABCDEF".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
        }

        private void ReadLenth_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789ABCDEF".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
        }

        private void password_text_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789ABCDEF".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
        }

        private void text_off_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789ABCDEF".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
        }

        private void txtEpc_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789ABCDEF".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
        }

        private void ReadPassward_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789ABCDEF".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
        }

        /// <summary>
        /// lock tag
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonLock_Click(object sender, EventArgs e)
        {
            UInt32 error = 0;
            string Epc_string = txtSelectedTag.Text.Replace(" ", "").Replace("0x", "");
            byte[] yu = { };

            if (Epc_string.Length % 2 != 0)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Please input correct epc." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                return;
            }
            yu = HexStringToByteArray(Epc_string);
            AsReader.TagMask tagMask = new AsReader.TagMask();
            tagMask.userMemoryBit1 = cbMaskUser1.Checked;
            tagMask.userMemoryBit2 = cbMaskUser2.Checked;
            tagMask.tidMemoryBit1 = cbMaskTID1.Checked;
            tagMask.tidMemoryBit2 = cbMaskTID2.Checked;
            tagMask.epcMemoryBit1 = cbMaskEPC1.Checked;
            tagMask.epcMemoryBit2 = cbMaskEPC2.Checked;
            tagMask.accessMemoryBit1 = cbMaskAccess1.Checked;
            tagMask.accessMemoryBit2 = cbMaskAccess2.Checked;
            tagMask.killPwdMemoryBit1 = cbMaskKill1.Checked;
            tagMask.killPwdMemoryBit2 = cbMaskKill2.Checked;

            AsReader.TagAction tagAction = new AsReader.TagAction();
            tagAction.userMemoryBit1 = cbActionUser1.Checked;
            tagAction.userMemoryBit2 = cbActionUser2.Checked;
            tagAction.tidMemoryBit1 = cbActionTID1.Checked;
            tagAction.tidMemoryBit2 = cbActionTID2.Checked;
            tagAction.epcMemoryBit1 = cbActionEPC1.Checked;
            tagAction.epcMemoryBit2 = cbActionEPC2.Checked;
            tagAction.accessMemoryBit1 = cbActionAccess1.Checked;
            tagAction.accessMemoryBit2 = cbActionAccess2.Checked;
            tagAction.killPwdMemoryBit1 = cbActionKill1.Checked;
            tagAction.killPwdMemoryBit2 = cbActionKill2.Checked;

            error = Device.LockMemory(tagMask, tagAction, Convert.ToUInt32(ReadPassward.Text == "" ? "0" : ReadPassward.Text, 16), yu);

            if (error == 1)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Lock Tag command sent failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
        }

        /// <summary>
        /// ANT power value
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void AntPowerOrReadTimeKeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = ("0123456789".IndexOf(Char.ToUpper(e.KeyChar)) < 0);
        }

        /// <summary>
        /// set channel
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSetChannel_Click(object sender, EventArgs e)
        {
            UInt32 error = Device.SetChannel((uint)Convert.ToInt32(cmbChannel.SelectedValue));

            if (error == 1)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Set Channel command sent failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
        }

        /// <summary>
        /// get channel
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnGetChannel_Click(object sender, EventArgs e)
        {
            uint channel = 0;
            uint error = 0;
            error = Device.GetChannel(ref channel);
            if (error == 0) cmbChannel.SelectedValue = Convert.ToInt32(channel);

            if (error == 1)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Get Channel command sent failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
        }

        ///// <summary>
        ///// set gain
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //private void btnSetGain_Click(object sender, EventArgs e)
        //{
        //    UInt32 error = Device.SetGain((Types.GainType)cmbGain.SelectedValue);

        //    if (error == 1)
        //    {
        //        this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Operate fail." + Environment.NewLine);
        //        this.Devmes.ScrollToCaret();
        //    }
        //}

        ///// <summary>
        ///// get gain
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //private void btnGetGain_Click(object sender, EventArgs e)
        //{
        //    Types.GainType gain = 0;
        //    uint error = 0;
        //    error = Device.GetGain(ref gain);
        //    if (error == 0) cmbGain.SelectedValue = Convert.ToInt32(gain);
        //    if (error == 1)
        //    {
        //        this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Operate fail." + Environment.NewLine);
        //        this.Devmes.ScrollToCaret();
        //    }
        //}

        /// <summary>
        /// set collision 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSetCollision_Click(object sender, EventArgs e)
        {
            UInt32 error = Device.SetAntiCollisionMode((Types.AntiCollisionMode)cmbCollision.SelectedValue);

            if (error == 1)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Set Collision command sent failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
        }

        bool getCollisionErr = false;
        /// <summary>
        /// get collision
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnGetCollision_Click(object sender, EventArgs e)
        {
            Types.AntiCollisionMode collision = 0;
            uint error = 0;
            error = Device.GetAntiCollisionMode(ref collision);
            if (error == 0) {
                cmbCollision.SelectedValue = Convert.ToInt32(collision);
                getCollisionErr = false;
            }
            if (error == 1)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Get Collision command sent failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                getCollisionErr = true;
            }
        }

        ///// <summary>
        ///// EpcRssi selected
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //private void cbEpcRssi_CheckedChanged(object sender, EventArgs e)
        //{
        //    if (cbEpcRssi.Checked)
        //    {
        //        cbPcEpc.Checked = false;
        //        cbEpcTid.Checked = false;
        //        gbAnt.Enabled = false;
        //    }
        //    gbAnt.Enabled = !(cbPcEpc.Checked || cbEpcTid.Checked || cbEpcRssi.Checked);
        //}

        ///// <summary>
        ///// EpcTid selected
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //private void cbEpcTid_CheckedChanged(object sender, EventArgs e)
        //{
        //    if (cbEpcTid.Checked)
        //    {
        //        cbPcEpc.Checked = false;
        //        cbEpcRssi.Checked = false;
        //        gbAnt.Enabled = false;
        //    }
        //    gbAnt.Enabled = !(cbPcEpc.Checked || cbEpcTid.Checked || cbEpcRssi.Checked);
        //}

        ///// <summary>
        ///// PcEpc selected
        ///// </summary>
        ///// <param name="sender"></param>
        ///// <param name="e"></param>
        //private void cbPcEpc_CheckedChanged(object sender, EventArgs e)
        //{
        //    if (cbPcEpc.Checked)
        //    {
        //        cbEpcTid.Checked = false;
        //        cbEpcRssi.Checked = false;
        //    }

        //    gbAnt.Enabled = !(cbPcEpc.Checked || cbEpcTid.Checked || cbEpcRssi.Checked);
        //}

        /// <summary>
        /// set read time
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSetReadTime_Click(object sender, EventArgs e)
        {
            UInt32 error = 0;
            if (checkReadTime(txtReadTime1.Text) == false ||
                checkReadTime(txtReadTime2.Text) == false ||
                checkReadTime(txtReadTime3.Text) == false ||
                checkReadTime(txtReadTime4.Text) == false ||
                checkReadTime(txtReadTime5.Text) == false ||
                checkReadTime(txtReadTime6.Text) == false ||
                checkReadTime(txtReadTime7.Text) == false ||
                checkReadTime(txtReadTime8.Text) == false)
            {
                string  msg = DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Please input correct antenna read time(10~2550).";
                this.Devmes.AppendText(msg + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                return;
            }
            error = Device.SetReadTime(
                Convert.ToUInt32(txtReadTime1.Text),
                Convert.ToUInt32(txtReadTime2.Text),
                Convert.ToUInt32(txtReadTime3.Text),
                Convert.ToUInt32(txtReadTime4.Text),
                Convert.ToUInt32(txtReadTime5.Text),
                Convert.ToUInt32(txtReadTime6.Text),
                Convert.ToUInt32(txtReadTime7.Text),
                Convert.ToUInt32(txtReadTime8.Text)
                );

            if (error == 1)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Set Read Time command sent failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
        }

        bool getReadTimeErr = false;
        private void btnGetReadTime_Click(object sender, EventArgs e)
        {
            UInt32 readTime1 = 0;
            UInt32 readTime2 = 0;
            UInt32 readTime3 = 0;
            UInt32 readTime4 = 0;
            UInt32 readTime5 = 0;
            UInt32 readTime6 = 0;
            UInt32 readTime7 = 0;
            UInt32 readTime8 = 0;
            UInt32 error = 0;

            error = Device.GetReadTime(ref readTime1, ref readTime2, ref readTime3, ref readTime4, ref readTime5, ref readTime6, ref readTime7, ref readTime8);
            if (error == 0)
            {
                txtReadTime1.Text = readTime1.ToString();
                txtReadTime2.Text = readTime2.ToString();
                txtReadTime3.Text = readTime3.ToString();
                txtReadTime4.Text = readTime4.ToString();
                txtReadTime5.Text = readTime5.ToString();
                txtReadTime6.Text = readTime6.ToString();
                txtReadTime7.Text = readTime7.ToString();
                txtReadTime8.Text = readTime8.ToString();
                getReadTimeErr = false;
            }

            if (error == 1)
            {
                txtReadTime1.Text = "";
                txtReadTime2.Text = "";
                txtReadTime3.Text = "";
                txtReadTime4.Text = "";
                txtReadTime5.Text = "";
                txtReadTime6.Text = "";
                txtReadTime7.Text = "";
                txtReadTime8.Text = "";
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Get Read Time command sent failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                getReadTimeErr = true;
            }
        }

        private void ClearTableData()
        {
            mTagHashTable.Clear();
            this.DatalistView.Items.Clear();
            selectedIndex = 0;
            this.Devmes.Text = "";
            this.lblCount.Text = "0";
            singluationCount = 0;
            lblTotalDuration.Text = "0";
            lblTotalSingulation.Text = "0";
            lblTotalUnique.Text = "0";
            lblSingulationRate.Text = "0";
            lblAllTagCnt.Text = "0";
        }

        /// <summary>
        /// 
        /// </summary>
        private void ControlsEnabled()
        {
            //isConnected:true => connect succeed
            this.InventorySet.Enabled = isConnected;
            this.gbSetGet.Enabled = isConnected;
            this.tabControl2.Enabled = isConnected;
            this.SelectTag.Enabled = isConnected;
            this.groupBox4.Enabled = isConnected;
            this.LockTag.Enabled = isConnected;
            this.Connect.Enabled = !isConnected;
            this.button2.Enabled = isConnected && connType == "VCP";
            this.button5.Enabled = !isConnected;
            this.btnTCPDiscon.Enabled = isConnected && connType == "TCP";
            this.ComPort.Enabled = !isConnected;
            this.txtBaudRate.Enabled = !isConnected;
            this.TcpPort.Enabled = !isConnected;
            this.cmbTCPIPAddr.Enabled = !isConnected;
            this.textBox4.Enabled = !isConnected;
            this.btnSearch.Enabled = !isConnected;
            this.gbCW.Enabled = isConnected;
            this.groupBox6.Enabled = isConnected;
            this.groupBox8.Enabled = isConnected;
            this.StartInventory.Enabled = isConnected;
            this.gbTypes.Enabled = isConnected;
        }

        /// <summary>
        /// 
        /// </summary>
        private void SetCombolList()
        {
            this.cmbTarget.DataSource = Device.getComboxList(typeof(Types.TargetType));
            this.cmbTarget.DisplayMember = "name";
            this.cmbTarget.ValueMember = "value";
            this.cmbTarget.SelectedIndex = 0;

            this.cmbAction.DataSource = Device.getComboxList(typeof(Types.ActionType));
            this.cmbAction.DisplayMember = "name";
            this.cmbAction.ValueMember = "value";
            this.cmbAction.SelectedIndex = 0;

            this.cmbRegion.DataSource = Device.getComboxList(typeof(Types.RegionType));
            this.cmbRegion.DisplayMember = "name";
            this.cmbRegion.ValueMember = "value";
            this.cmbRegion.SelectedIndex = 0;

            this.cmbSession.DataSource = Device.getComboxList(typeof(Types.SessionType));
            this.cmbSession.DisplayMember = "name";
            this.cmbSession.ValueMember = "value";
            this.cmbSession.SelectedIndex = 0;

            //this.cmbChannel.DataSource = Device.getComboxList(typeof(Types.ChannelType));
            //this.cmbChannel.DisplayMember = "name";
            //this.cmbChannel.ValueMember = "value";
            //this.cmbChannel.SelectedIndex = 0;

            //this.cmbGain.DataSource = Device.getComboxList(typeof(Types.GainType));
            //this.cmbGain.DisplayMember = "name";
            //this.cmbGain.ValueMember = "value";
            //this.cmbGain.SelectedIndex = 0;

            this.cmbCollision.DataSource = Device.getComboxList(typeof(Types.AntiCollisionMode));
            this.cmbCollision.DisplayMember = "name";
            this.cmbCollision.ValueMember = "value";
            this.cmbCollision.SelectedIndex = 0;
        }

        private void StopInventory()
        {
            StartInventory.Text = "Start";
            StartInventory.Enabled = false;
            readTimer.Enabled = false;
            //if (m_bInventory) while (Device.StopInventory() != 0) ;
            if (m_bInventory)
            {
                Device.StopInventory();
            }
            m_bInventory = false;
            StartInventory.Enabled = true;
            ClearTableData();
        }

        public static string[] GetPortList()
        {
            return SerialPort.GetPortNames();
        }

        void SetReaderTagDataList(AsReader.InventoryResult tagcallbackdata)
        {
            singluationCount ++;

            mReadTag = tagcallbackdata;
            string epc = tagcallbackdata.tagdata.epc;
            string tid = tagcallbackdata.tagdata.tid;

            if (epc != null)
            {
                if (!mTagHashTable.ContainsKey(epc))
                {
                    mTagHashTable.Add(epc, this.DatalistView.Items.Count);

                    ListViewItem item = new ListViewItem();
                    item.Text = (this.DatalistView.Items.Count + 1).ToString();
                    item.SubItems.Add(Convert.ToString(tagcallbackdata.tagdata.pc));
                    item.SubItems.Add(Convert.ToString(tagcallbackdata.tagdata.epc));
                    //item.SubItems.Add(Convert.ToString(tagcallbackdata.tagdata.tid));
                    item.SubItems.Add(Convert.ToString(tagcallbackdata.rssi));
                    item.SubItems.Add(Convert.ToString(tagcallbackdata.tagdata.data));
                    item.SubItems.Add(Convert.ToString(tagcallbackdata.antenna));
                    item.SubItems.Add(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss"));
                    item.SubItems.Add("1");
                    this.DatalistView.Items.Add(item);
                }
                else
                {
                    int count = (int)mTagHashTable[epc];
                    ListViewItem item = this.DatalistView.Items[count];
                    item.SubItems[3].Text = Convert.ToString(tagcallbackdata.rssi);
                    item.SubItems[4].Text = Convert.ToString(tagcallbackdata.tagdata.data);
                    item.SubItems[5].Text = Convert.ToString(tagcallbackdata.antenna);
                    item.SubItems[6].Text = DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss");
                    item.SubItems[7].Text = (Convert.ToInt32(item.SubItems[7].Text) + 1).ToString();
                }

            }
            if (epc == null && tid != null)
            {
                if (!mTagHashTable.ContainsKey(tid))
                {
                    mTagHashTable.Add(tid, this.DatalistView.Items.Count);

                    ListViewItem item = new ListViewItem();
                    item.Text = (this.DatalistView.Items.Count + 1).ToString();
                    item.SubItems.Add(Convert.ToString(tagcallbackdata.tagdata.pc));
                    item.SubItems.Add(Convert.ToString(tagcallbackdata.tagdata.epc));
                    //item.SubItems.Add(Convert.ToString(tagcallbackdata.tagdata.tid));
                    item.SubItems.Add(Convert.ToString(tagcallbackdata.rssi));
                    item.SubItems.Add(Convert.ToString(tagcallbackdata.tagdata.data));
                    item.SubItems.Add(Convert.ToString(tagcallbackdata.antenna));
                    item.SubItems.Add(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss"));
                    item.SubItems.Add("1");
                    this.DatalistView.Items.Add(item);
                }
                else
                {
                    int count = (int)mTagHashTable[tid];

                    ListViewItem item = this.DatalistView.Items[count];
                    item.SubItems[3].Text = Convert.ToString(tagcallbackdata.rssi);
                    item.SubItems[4].Text = Convert.ToString(tagcallbackdata.tagdata.data);
                    item.SubItems[5].Text = Convert.ToString(tagcallbackdata.antenna);
                    item.SubItems[6].Text = (DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss"));
                    item.SubItems[7].Text = (Convert.ToInt32(item.SubItems[7].Text) + 1).ToString();
                }
            }

            
            lblTotalSingulation.Text = singluationCount.ToString();
            lblTotalUnique.Text = DatalistView.Items.Count.ToString();
            lblAllTagCnt.Text = DatalistView.Items.Count.ToString();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="rdtag"></param>
        private void ShowTagData(AsReader.InventoryResult rdtag)
        {
            ProcessDelegate mainProcess = delegate ()
            {
                SetReaderTagDataList(rdtag);

                if (this.DatalistView.Items.Count > 0)
                {
                    this.DatalistView.Items[selectedIndex].Selected = true;
                    this.DatalistView.Items[selectedIndex].EnsureVisible();
                }
                this.lblCount.Text = this.DatalistView.Items.Count.ToString();
            };

            this.Invoke(mainProcess);

        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        private UInt32 StartInventoryByTypes()
        {
            UInt32 error = 0;
            bool parseRet = false;
            byte outTagCount = 0;
            parseRet = byte.TryParse(txtTagCount.Text, out outTagCount);

            if (parseRet == false)
            {
                string msg = DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Parameter error: Tag Count.";
                this.Devmes.AppendText(msg + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                return 999;
            }
            byte outElapsedTime = 0;
            parseRet = byte.TryParse(txtElapsedTime.Text, out outElapsedTime);

            if (parseRet == false)
            {
                string msg = DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Parameter error: Elapsed Time.";
                this.Devmes.AppendText(msg + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                return 999;
            }

            ushort inventoryRound = 0;
            parseRet = ushort.TryParse(this.txtInventoryRound.Text, out inventoryRound);

            if (parseRet == false)
            {
                string msg = DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Parameter error: Inventory Round.";
                this.Devmes.AppendText(msg + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                return 999;
            }
            error = Device.StartInventory(
                rbRssiOn.Checked ? true : false,
                outTagCount,
                outElapsedTime,
                inventoryRound,
                cbAnt1.Checked,
                cbAnt2.Checked,
                cbAnt3.Checked,
                cbAnt4.Checked,
                cbAnt5.Checked,
                cbAnt6.Checked,
                cbAnt7.Checked,
                cbAnt8.Checked);
            return error;
        }

        private bool checkReadTime(string readTime) {
            if (readTime == "")
            {
                return false;
            }
            else if (Convert.ToUInt32(readTime) < 10 || Convert.ToUInt32(readTime) > 2550)
            {
                return false;
            }
            return true;
        }

        private void ShowErrorMsg(uint error)
        {
            ProcessDelegate mainProcess = delegate ()
            {
                ShowErrorMessage(error);
            };

            this.Invoke(mainProcess);

        }

        private void ShowErrorMessage(uint error)
        {
            if (Enum.IsDefined(typeof(Types.ErrorCode), Convert.ToInt32(error)))
            {
                string message = Enum.Parse(typeof(Types.ErrorCode), Convert.ToString(error)).ToString();
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " 0x" + Convert.ToString(error, 16) + ":" + message + Environment.NewLine);
            }
            else
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " 0x" + Convert.ToString(error, 16) + ":" + " Unkown error." + Environment.NewLine);
            }
            this.Devmes.ScrollToCaret();
        }

        private void ShowSuccessMsg(uint success)
        {
            ProcessDelegate mainProcess = delegate ()
            {
                ShowSuccessMessage(success);
            };

            this.Invoke(mainProcess);
        }
        
        private void ShowSuccessMessage(uint success)
        {
            if (Enum.IsDefined(typeof(Types.SuccessCode), Convert.ToInt32(success)))
            {
                string message = Enum.Parse(typeof(Types.SuccessCode), Convert.ToString(success)).ToString();
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " 0x" + Convert.ToString(success, 16) + ":" + message + Environment.NewLine);
            }
            else
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " 0x" + Convert.ToString(success, 16) + ":" + " Unkown success code." + Environment.NewLine);
            }
            this.Devmes.ScrollToCaret();
        }

        private void SetStaticIP_Btn_Click(object sender, EventArgs e)
        {
            if (Device.SetStaticIP(StaticIP_Text.Text, SubnetMask_Text.Text, Gateway_Text.Text, Dns_Text.Text))
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Set static ip success" + Environment.NewLine);
            }
            else
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + "Set static ip error" + Environment.NewLine);
            }
        }


        private void button1_Click_1(object sender, EventArgs e)
        {
            string sdkVersion = "";
            this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Get SDK Version " + Environment.NewLine);
            Device.GetSdkVersion(ref sdkVersion);
            tx_sdkversion.Text = sdkVersion;
        }

        private void btnUpdateRegistry_Click(object sender, EventArgs e)
        {
           bool successed = Device.UpdateRegistry();
            if (!successed)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Update Registry command sent failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
        }

        private void btnSetIdleTime_Click(object sender, EventArgs e)
        {
            uint error = 0;
            uint idelTime = 0;
            if (uint.TryParse(txtIdelTime.Text, out idelTime) == false) {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Parameter error." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                return;
            }
            error = Device.SetIdelTime(idelTime);

            if (error == 1)
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Set Idel Time command sent failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
            }
        }

        bool getIdleTimeErr = false;
        private void btnGetIdleTime_Click(object sender, EventArgs e)
        {
            uint idelTime = 0;
            uint error = 0;
            error = Device.GetIdelTime(ref idelTime);
            if (error == 0)
            {
                txtIdelTime.Text = idelTime.ToString();
                getIdleTimeErr = false;
            }
            else {
                txtIdelTime.Text = "";
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Get Idel Time command sent failed." + Environment.NewLine);
                this.Devmes.ScrollToCaret();
                getIdleTimeErr = true;
            }

        }
        private void readTimer_Tick(object sender, EventArgs e)
        {
            int duration = (System.Environment.TickCount - total_time);
            lblTotalDuration.Text = duration.ToString();
            lblSingulationRate.Text = (((float)singluationCount * 1000) / (float)duration).ToString("F01");
        }

        private void txtPower1_TextChanged(object sender, EventArgs e)
        {

        }

        private void gbCW_Enter(object sender, EventArgs e)
        {

        }

        private void groupBox6_Enter(object sender, EventArgs e)
        {

        }

        Dictionary<Types.RegionType, object> defaultRegionChannel = new Dictionary<Types.RegionType, object>{
            { Types.RegionType.REGION_US, Types.USChannelType.CHANNEL_25},
            { Types.RegionType.REGION_US_NARROW, Types.USChannelType.CHANNEL_25},
            { Types.RegionType.REGION_EUROPE, Types.EuropeChannelType.CHANNEL_10},
            { Types.RegionType.REGION_JAPAN, Types.JPChannelType.CHANNEL_24},
            { Types.RegionType.REGION_CHINA2, Types.ChinaChannelType.CHANNEL_10},
            { Types.RegionType.REGION_BRAZIL, Types.BrazilChannelType.CHANNEL_60},
        };
        private void button3_Click(object sender, EventArgs e)
        {
            Types.RegionType regionType = (Types.RegionType)cmbRegion.SelectedValue;
            string maxPower = Device.getMaxPowerByRegion(regionType);
            txtPower1.Text = txtPower2.Text = txtPower3.Text = txtPower4.Text = txtPower5.Text = txtPower6.Text = txtPower7.Text = txtPower8.Text = maxPower;
            txtReadTime1.Text = txtReadTime2.Text = txtReadTime3.Text = txtReadTime4.Text = txtReadTime5.Text = txtReadTime6.Text = txtReadTime7.Text = txtReadTime8.Text = "150";
            txtIdelTime.Text = "50";
            cmbSession.SelectedValue = Convert.ToInt32(Types.SessionType.SESSION_S0);
            cmbChannel.SelectedValue = Convert.ToInt32(defaultRegionChannel[regionType]);
            cmbCollision.SelectedValue = Convert.ToInt32(Types.AntiCollisionMode.FixedQ);
            Task.Run(() =>
            {
                this.BeginInvoke(new Action(() =>
                {
                    btnSetPowerWithANT_Click(SetPower, e);
                }));
                Thread.Sleep(200);
                this.BeginInvoke(new Action(() =>
                {
                    btnSetReadTime_Click(btnSetReadTime, e);
                }));
                Thread.Sleep(200);
                this.BeginInvoke(new Action(() =>
                {
                    btnSetIdleTime_Click(button8, e);
                }));
                Thread.Sleep(200);
                this.BeginInvoke(new Action(() =>
                {
                    SetSession_Click(SetSession, e);
                }));
                Thread.Sleep(200);
                this.BeginInvoke(new Action(() =>
                {
                    btnSetChannel_Click(btnSetChannel, e);
                }));
                Thread.Sleep(200);
                this.BeginInvoke(new Action(() =>
                {
                    btnSetCollision_Click(btnSetCollision, e);
                }));
                this.BeginInvoke(new Action(() =>
                {
                    GetPower_Click(GetPower, e);
                }));
                Thread.Sleep(200);
                this.BeginInvoke(new Action(() =>
                {
                    btnGetReadTime_Click(btnGetReadTime, e);
                }));
                Thread.Sleep(200);
                this.BeginInvoke(new Action(() =>
                {
                    btnGetIdleTime_Click(button11, e);
                }));
                Thread.Sleep(200);
                this.BeginInvoke(new Action(() =>
                {
                    GetSession_Click(GetSession, e);
                }));
                Thread.Sleep(200);
                this.BeginInvoke(new Action(() =>
                {
                    btnGetChannel_Click(btnGetChannel, e);
                }));
                Thread.Sleep(200);
                this.BeginInvoke(new Action(() =>
                {
                    btnGetCollision_Click(btnGetCollision, e);
                }));
            });
        }

        private void label3_Click(object sender, EventArgs e)
        {

        }

        private void AsReaderP31N_Demo_Tool_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (isConnected)
            {
                Device.DisConnect();
            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            frmFirmwareUpdate frm = new frmFirmwareUpdate();
            frm.ShowDialog();
            //frmFKirmwareUpdate frm = new frmFirmwareUpdate();
            //frm.ShowDialog();
        }


        int button_num = 0;
        private void button6_Click(object sender, EventArgs e)
        {
            string msg = Device.GetFWVersion();
            if (!string.IsNullOrEmpty(msg))
            {
                label50.Text = msg;
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Get Firmware Version " + Environment.NewLine);
            }
            else
            {
                button_num++;

                if (button_num < 5)
                {
                    button6_Click(null, null);
                }
                else
                { 
                    this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Get Firmware Version " + Environment.NewLine);
                }
            }
        }

        private void btnCsvOut_Click(object sender, EventArgs e)
        {
            if (DatalistView.Items.Count == 0) return;
            string fileName = DateTime.Now.ToString("yyyyMMddHHmmssfff") + ".csv";
            System.Threading.Thread th = new System.Threading.Thread(ExportCSV);
            th.Start(fileName);
        }
        private void ExportCSV(object strFileName)
        {
            this.Invoke((EventHandler)delegate {
                try
                {
                    string savePath = ConfigurationManager.AppSettings["CsvDefaultPath"];
                    if (Directory.Exists(savePath) == false)
                    {
                        MessageBox.Show(savePath + " folder does not exists.");
                        return;
                    }
                    SaveFileDialog sfd = new SaveFileDialog();
                    sfd.RestoreDirectory = true;
                    sfd.Filter = "csv(*.csv)|*.csv|all(*.*)|*.*";
                    sfd.FileName = strFileName.ToString();
                    if (savePath != "") sfd.InitialDirectory = savePath;
                    //sfd.InitialDirectory = Application.StartupPath;
                    if (sfd.ShowDialog() == DialogResult.OK)
                    {
                        FileStream fs = new FileStream(sfd.FileName, FileMode.Create);
                        StreamWriter sw = new StreamWriter(fs, Encoding.Default);
                        //header
                        for (int i = 0; i < DatalistView.Columns.Count; i++)
                        {
                            sw.Write(DatalistView.Columns[i].Text);
                            if (DatalistView.Columns.Count - 1 > i) sw.Write(",");
                        }
                        sw.Write(Environment.NewLine);
                        for (int i = 0; i < DatalistView.Items.Count; i++)
                        {
                            for (int j = 0; j < DatalistView.Items[i].SubItems.Count; j++)
                            {
                                sw.Write(DatalistView.Items[i].SubItems[j].Text);
                                if (DatalistView.Items[i].SubItems.Count - 1 > j) sw.Write(",");
                            }
                            sw.Write(Environment.NewLine);
                        }
                        sw.Flush();
                        sw.Close();
                        this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Export csv file successed." + Environment.NewLine);
                        this.Devmes.ScrollToCaret();
                    }
                }
                catch (Exception ex)
                {
                    this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Export csv file failed." + ex.Message + Environment.NewLine);
                    this.Devmes.ScrollToCaret();
                }
            });

        }

        private void button7_Click_1(object sender, EventArgs e)
        {
            if (Device.SetDHCP())
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Set dhcp success" + Environment.NewLine);
            }
            else
            {
                this.Devmes.AppendText(DateTime.Now.ToString("yyyy/MM/dd HH:mm:ss") + " Set dhcp error" + Environment.NewLine);
            }
        }
    }
}
