﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO.Ports;
using System.Collections;
using AsReaderP31N;
using System.Data;
using System.ComponentModel;

namespace AsReaderP51N_Demo_Tool
{
    class Device
    {
        private static AsReader asreader = new AsReaderP31N.AsReader();
        public delegate void CallBackResultTagData(AsReader.InventoryResult data);
        public delegate void CallBackResultError(uint error);
        public delegate void CallBackResultSuccess(uint error);
        public static CallBackResultTagData callBackResultTagData = null;
        public static CallBackResultError callBackResultError = null;
        public static CallBackResultSuccess callBackResultSuccess = null;

        static Dictionary<Types.ActionType, string> dicAction = new Dictionary<Types.ActionType, string>{
            { Types.ActionType.ACTION_ASLINVA_DSLINVB, "ASLINVA_DSLINVB" },
            { Types.ActionType.ACTION_ASLINVA_NOTHING,"ASLINVA_NOTHING" },
            { Types.ActionType.ACTION_DSLINVB_ASLINVA,"DSLINVB_ASLINVA" },
            { Types.ActionType.ACTION_DSLINVB_NOTHING,"DSLINVB_NOTHING" },
            { Types.ActionType.ACTION_NOTHING_ASLINVA,"NOTHING_ASLINVA" },
            { Types.ActionType.ACTION_NOTHING_DSLINVB,"NOTHING_DSLINVB" },
            { Types.ActionType.ACTION_NOTHING_NSLINVS,"NOTHING_NSLINVS" },
            { Types.ActionType.ACTION_NSLINVS_NOTHING,"NSLINVS_NOTHING" },
        };

        static Dictionary<Types.ChinaChannelType, string> dicChinaChannel = new Dictionary<Types.ChinaChannelType, string>{
            { Types.ChinaChannelType.CHANNEL_1,"CHANNEL_1" },
            { Types.ChinaChannelType.CHANNEL_2,"CHANNEL_2" },
            { Types.ChinaChannelType.CHANNEL_3,"CHANNEL_3" },
            { Types.ChinaChannelType.CHANNEL_4,"CHANNEL_4" },
            { Types.ChinaChannelType.CHANNEL_5,"CHANNEL_5" },
            { Types.ChinaChannelType.CHANNEL_6,"CHANNEL_6" },
            { Types.ChinaChannelType.CHANNEL_7,"CHANNEL_7" },
            { Types.ChinaChannelType.CHANNEL_8,"CHANNEL_8" },
            { Types.ChinaChannelType.CHANNEL_9,"CHANNEL_9" },
            { Types.ChinaChannelType.CHANNEL_10,"CHANNEL_10" },
            { Types.ChinaChannelType.CHANNEL_11,"CHANNEL_11" },
            { Types.ChinaChannelType.CHANNEL_12,"CHANNEL_12" },
            { Types.ChinaChannelType.CHANNEL_13,"CHANNEL_13" },
            { Types.ChinaChannelType.CHANNEL_14,"CHANNEL_14" },
            { Types.ChinaChannelType.CHANNEL_15,"CHANNEL_15" },
            { Types.ChinaChannelType.CHANNEL_16,"CHANNEL_16" },
            { Types.ChinaChannelType.CHANNEL_17,"CHANNEL_17" },
            { Types.ChinaChannelType.CHANNEL_18,"CHANNEL_18" },
            { Types.ChinaChannelType.CHANNEL_19,"CHANNEL_19" },
            { Types.ChinaChannelType.CHANNEL_20,"CHANNEL_20" },
        };

        static Dictionary<Types.EuropeChannelType, string> diEuropeChannel = new Dictionary<Types.EuropeChannelType, string>{
            { Types.EuropeChannelType.CHANNEL_4,"CHANNEL_4" },
            { Types.EuropeChannelType.CHANNEL_7,"CHANNEL_7" },
            { Types.EuropeChannelType.CHANNEL_10,"CHANNEL_10" },
            { Types.EuropeChannelType.CHANNEL_13,"CHANNEL_13" },
        };

        static Dictionary<Types.JPChannelType, string> diJPChannel = new Dictionary<Types.JPChannelType, string>{
            { Types.JPChannelType.CHANNEL_24,"CHANNEL_24" },
            { Types.JPChannelType.CHANNEL_25,"CHANNEL_25" },
            { Types.JPChannelType.CHANNEL_26,"CHANNEL_26" },
            { Types.JPChannelType.CHANNEL_27,"CHANNEL_27" },
            { Types.JPChannelType.CHANNEL_28,"CHANNEL_28" },
            { Types.JPChannelType.CHANNEL_29,"CHANNEL_29" },
            { Types.JPChannelType.CHANNEL_30,"CHANNEL_30" },
            { Types.JPChannelType.CHANNEL_31,"CHANNEL_31" },
            { Types.JPChannelType.CHANNEL_32,"CHANNEL_32" },
            { Types.JPChannelType.CHANNEL_33,"CHANNEL_33" },
            { Types.JPChannelType.CHANNEL_34,"CHANNEL_34" },
            { Types.JPChannelType.CHANNEL_35,"CHANNEL_35" },
            { Types.JPChannelType.CHANNEL_36,"CHANNEL_36" },
        };

        static Dictionary<Types.BrazilChannelType, string> dicBrazilChannel = new Dictionary<Types.BrazilChannelType, string>{
            { Types.BrazilChannelType.CHANNEL_2,"CHANNEL_2" },
            { Types.BrazilChannelType.CHANNEL_5,"CHANNEL_5" },
            { Types.BrazilChannelType.CHANNEL_7,"CHANNEL_7" },
            { Types.BrazilChannelType.CHANNEL_8,"CHANNEL_8" },
            { Types.BrazilChannelType.CHANNEL_9,"CHANNEL_9" },
            { Types.BrazilChannelType.CHANNEL_12,"CHANNEL_12" },
            { Types.BrazilChannelType.CHANNEL_13,"CHANNEL_13" },
            { Types.BrazilChannelType.CHANNEL_14,"CHANNEL_14" },
            { Types.BrazilChannelType.CHANNEL_15,"CHANNEL_15" },
            { Types.BrazilChannelType.CHANNEL_17,"CHANNEL_17" },
            { Types.BrazilChannelType.CHANNEL_18,"CHANNEL_18" },
            { Types.BrazilChannelType.CHANNEL_19,"CHANNEL_19" },
            { Types.BrazilChannelType.CHANNEL_22,"CHANNEL_22" },
            { Types.BrazilChannelType.CHANNEL_23,"CHANNEL_23" },
            { Types.BrazilChannelType.CHANNEL_24,"CHANNEL_24" },
            { Types.BrazilChannelType.CHANNEL_25,"CHANNEL_25" },
            { Types.BrazilChannelType.CHANNEL_27,"CHANNEL_27" },
            { Types.BrazilChannelType.CHANNEL_30,"CHANNEL_30" },
            { Types.BrazilChannelType.CHANNEL_31,"CHANNEL_31" },
            { Types.BrazilChannelType.CHANNEL_32,"CHANNEL_32" },
            { Types.BrazilChannelType.CHANNEL_34,"CHANNEL_34" },
            { Types.BrazilChannelType.CHANNEL_36,"CHANNEL_36" },
            { Types.BrazilChannelType.CHANNEL_38,"CHANNEL_38" },
            { Types.BrazilChannelType.CHANNEL_39,"CHANNEL_39" },
            { Types.BrazilChannelType.CHANNEL_40,"CHANNEL_40" },
            { Types.BrazilChannelType.CHANNEL_42,"CHANNEL_42" },
            { Types.BrazilChannelType.CHANNEL_43,"CHANNEL_43" },
            { Types.BrazilChannelType.CHANNEL_45,"CHANNEL_45" },
            { Types.BrazilChannelType.CHANNEL_60,"CHANNEL_60" },
            { Types.BrazilChannelType.CHANNEL_61,"CHANNEL_61" },
            { Types.BrazilChannelType.CHANNEL_63,"CHANNEL_63" },
            { Types.BrazilChannelType.CHANNEL_68,"CHANNEL_68" },
            { Types.BrazilChannelType.CHANNEL_70,"CHANNEL_70" },
            { Types.BrazilChannelType.CHANNEL_71,"CHANNEL_71" },
            { Types.BrazilChannelType.CHANNEL_72,"CHANNEL_72" },
            { Types.BrazilChannelType.CHANNEL_74,"CHANNEL_74" },
            { Types.BrazilChannelType.CHANNEL_77,"CHANNEL_77" },
            { Types.BrazilChannelType.CHANNEL_78,"CHANNEL_78" },
            { Types.BrazilChannelType.CHANNEL_81,"CHANNEL_81" },
            { Types.BrazilChannelType.CHANNEL_83,"CHANNEL_83" },
            { Types.BrazilChannelType.CHANNEL_84,"CHANNEL_84" },
            { Types.BrazilChannelType.CHANNEL_85,"CHANNEL_85" },
            { Types.BrazilChannelType.CHANNEL_86,"CHANNEL_86" },
            { Types.BrazilChannelType.CHANNEL_88,"CHANNEL_88" },
            { Types.BrazilChannelType.CHANNEL_89,"CHANNEL_89" },
            { Types.BrazilChannelType.CHANNEL_90,"CHANNEL_90" },
            { Types.BrazilChannelType.CHANNEL_93,"CHANNEL_93" },
            { Types.BrazilChannelType.CHANNEL_96,"CHANNEL_96" },
            { Types.BrazilChannelType.CHANNEL_97,"CHANNEL_97" },
            { Types.BrazilChannelType.CHANNEL_99,"CHANNEL_99" },
            { Types.BrazilChannelType.CHANNEL_100,"CHANNEL_100" },
            { Types.BrazilChannelType.CHANNEL_101,"CHANNEL_101" },
            { Types.BrazilChannelType.CHANNEL_102,"CHANNEL_102" },
            { Types.BrazilChannelType.CHANNEL_103,"CHANNEL_103" },
            { Types.BrazilChannelType.CHANNEL_104,"CHANNEL_104" },
            { Types.BrazilChannelType.CHANNEL_105,"CHANNEL_105" },
            { Types.BrazilChannelType.CHANNEL_106,"CHANNEL_106" },
            { Types.BrazilChannelType.CHANNEL_107,"CHANNEL_107" },
            { Types.BrazilChannelType.CHANNEL_108,"CHANNEL_108" },
            { Types.BrazilChannelType.CHANNEL_109,"CHANNEL_109" },
            { Types.BrazilChannelType.CHANNEL_110,"CHANNEL_110" },
            { Types.BrazilChannelType.CHANNEL_112,"CHANNEL_112" },
            { Types.BrazilChannelType.CHANNEL_113,"CHANNEL_113" },
        };

        static Dictionary<Types.USChannelType, string> dicUSChannel = new Dictionary<Types.USChannelType, string>{
            { Types.USChannelType.CHANNEL_1,"CHANNEL_1" },
            { Types.USChannelType.CHANNEL_2,"CHANNEL_2" },
            { Types.USChannelType.CHANNEL_3,"CHANNEL_3" },
            { Types.USChannelType.CHANNEL_4,"CHANNEL_4" },
            { Types.USChannelType.CHANNEL_5,"CHANNEL_5" },
            { Types.USChannelType.CHANNEL_6,"CHANNEL_6" },
            { Types.USChannelType.CHANNEL_7,"CHANNEL_7" },
            { Types.USChannelType.CHANNEL_8,"CHANNEL_8" },
            { Types.USChannelType.CHANNEL_9,"CHANNEL_9" },
            { Types.USChannelType.CHANNEL_10,"CHANNEL_10" },
            { Types.USChannelType.CHANNEL_11,"CHANNEL_11" },
            { Types.USChannelType.CHANNEL_12,"CHANNEL_12" },
            { Types.USChannelType.CHANNEL_13,"CHANNEL_13" },
            { Types.USChannelType.CHANNEL_14,"CHANNEL_14" },
            { Types.USChannelType.CHANNEL_15,"CHANNEL_15" },
            { Types.USChannelType.CHANNEL_16,"CHANNEL_16" },
            { Types.USChannelType.CHANNEL_17,"CHANNEL_17" },
            { Types.USChannelType.CHANNEL_18,"CHANNEL_18" },
            { Types.USChannelType.CHANNEL_19,"CHANNEL_19" },
            { Types.USChannelType.CHANNEL_20,"CHANNEL_20" },
            { Types.USChannelType.CHANNEL_21,"CHANNEL_21" },
            { Types.USChannelType.CHANNEL_22,"CHANNEL_22" },
            { Types.USChannelType.CHANNEL_23,"CHANNEL_23" },
            { Types.USChannelType.CHANNEL_24,"CHANNEL_24" },
            { Types.USChannelType.CHANNEL_25,"CHANNEL_25" },
            { Types.USChannelType.CHANNEL_26,"CHANNEL_26" },
            { Types.USChannelType.CHANNEL_27,"CHANNEL_27" },
            { Types.USChannelType.CHANNEL_28,"CHANNEL_28" },
            { Types.USChannelType.CHANNEL_29,"CHANNEL_29" },
            { Types.USChannelType.CHANNEL_30,"CHANNEL_30" },
            { Types.USChannelType.CHANNEL_31,"CHANNEL_31" },
            { Types.USChannelType.CHANNEL_32,"CHANNEL_32" },
            { Types.USChannelType.CHANNEL_33,"CHANNEL_33" },
            { Types.USChannelType.CHANNEL_34,"CHANNEL_34" },
            { Types.USChannelType.CHANNEL_35,"CHANNEL_35" },
            { Types.USChannelType.CHANNEL_36,"CHANNEL_36" },
            { Types.USChannelType.CHANNEL_37,"CHANNEL_37" },
            { Types.USChannelType.CHANNEL_38,"CHANNEL_38" },
            { Types.USChannelType.CHANNEL_39,"CHANNEL_39" },
            { Types.USChannelType.CHANNEL_40,"CHANNEL_40" },
            { Types.USChannelType.CHANNEL_41,"CHANNEL_41" },
            { Types.USChannelType.CHANNEL_42,"CHANNEL_42" },
            { Types.USChannelType.CHANNEL_43,"CHANNEL_43" },
            { Types.USChannelType.CHANNEL_44,"CHANNEL_44" },
            { Types.USChannelType.CHANNEL_45,"CHANNEL_45" },
            { Types.USChannelType.CHANNEL_46,"CHANNEL_46" },
            { Types.USChannelType.CHANNEL_47,"CHANNEL_47" },
            { Types.USChannelType.CHANNEL_48,"CHANNEL_48" },
            { Types.USChannelType.CHANNEL_49,"CHANNEL_49" },
            { Types.USChannelType.CHANNEL_50,"CHANNEL_50" },
        };


        static Dictionary<Types.AntiCollisionMode, string> dicCollision = new Dictionary<Types.AntiCollisionMode, string>{
            { Types.AntiCollisionMode.DynamicQ, "DynamicQ" },
            { Types.AntiCollisionMode.FixedQ,"FixedQ" }
        };

        static Dictionary<Types.DRType, string> dicDr = new Dictionary<Types.DRType, string>{
            { Types.DRType.DR_64_3, "DR_64_3" },
            { Types.DRType.DR_8,"DR_8" }
        };

        static Dictionary<Types.MType, string> dicM = new Dictionary<Types.MType, string>{
            { Types.MType.M1, "M1" },
            { Types.MType.M2,"M2" },
            { Types.MType.M4,"M4" },
            { Types.MType.M8,"M8" },
        };

        static Dictionary<Types.TRextType, string> dicTrext = new Dictionary<Types.TRextType, string>{
            { Types.TRextType.NO_Pilot_Tone, "NO_Pilot_Tone" },
            { Types.TRextType.Use_Pilot_Tone,"Use_Pilot_Tone" },
        };

        static Dictionary<Types.SelType, string> dicSel = new Dictionary<Types.SelType, string>{
            { Types.SelType.SEL_ALL, "SEL_ALL" },
            { Types.SelType.SEL_SL,"SEL_SL" },
            { Types.SelType.SEL_SL_N,"SEL_SL_N" },
        };

        static Dictionary<Types.SessionType, string> dicQrySession = new Dictionary<Types.SessionType, string>{
            { Types.SessionType.SESSION_S0, "SESSION_S0" },
            { Types.SessionType.SESSION_S1,"SESSION_S1" },
            { Types.SessionType.SESSION_S2,"SESSION_S2" },
            { Types.SessionType.SESSION_S3,"SESSION_S3" },
        };

        static Dictionary<Types.TargetABType, string> dicQryTarget = new Dictionary<Types.TargetABType, string>{
            { Types.TargetABType.TARGET_A,"TARGET_A" },
            { Types.TargetABType.TARGET_B,"TARGET_B" },
        };

        static Dictionary<Types.QType, string> dicQ = new Dictionary<Types.QType, string>{
            { Types.QType.Q0, "Q0" },
            { Types.QType.Q1,"Q1" },
            { Types.QType.Q2,"Q2" },
            { Types.QType.Q3,"Q3" },
            { Types.QType.Q4,"Q4" },
            { Types.QType.Q5,"Q5" },
            { Types.QType.Q6,"Q6" },
            { Types.QType.Q7,"Q7" },
            { Types.QType.Q8,"Q8" },
            { Types.QType.Q9,"Q9" },
            { Types.QType.Q10,"Q10" },
            { Types.QType.Q11,"Q11" },
            { Types.QType.Q12,"Q12" },
            { Types.QType.Q13,"Q13" },
            { Types.QType.Q14,"Q14" },
            { Types.QType.Q15,"Q15" },
        };

        static Dictionary<Types.GainType, string> dicGain = new Dictionary<Types.GainType, string>{
            { Types.GainType.HIGH_GAIN, "HIGH_GAIN" },
            { Types.GainType.LOW_GAIN,"LOW_GAIN" },
        };

        static Dictionary<Types.RegionType, string> dicRegion = new Dictionary<Types.RegionType, string>{
            { Types.RegionType.REGION_BRAZIL, "REGION_BRAZIL" },
            { Types.RegionType.REGION_CHINA2,"REGION_CHINA2" },
            { Types.RegionType.REGION_EUROPE,"REGION_EUROPE" },
            { Types.RegionType.REGION_JAPAN,"REGION_JAPAN" },
            { Types.RegionType.REGION_US,"REGION_US" },
            { Types.RegionType.REGION_US_NARROW,"REGION_US_NARROW" },
        };

        static Dictionary<Types.SessionType, string> dicSession = new Dictionary<Types.SessionType, string>{
            { Types.SessionType.SESSION_S0,"0" },
            { Types.SessionType.SESSION_S1,"1" },
            { Types.SessionType.SESSION_S2,"2" },
            { Types.SessionType.SESSION_S3,"3" },
        };

        static Dictionary<Types.TargetType, string> dicTarget = new Dictionary<Types.TargetType, string>{
            { Types.TargetType.SESSION_S0, "SESSION_S0" },
            { Types.TargetType.SESSION_S1,"SESSION_S1" },
            { Types.TargetType.SESSION_S2,"SESSION_S2" },
            { Types.TargetType.SESSION_S3,"SESSION_S3" },
            { Types.TargetType.SL_FLAG,"SL_FLAG" },
        };

        /// <summary>
        /// 
        /// </summary>
        /// <param name="info"></param>
        public static void GetDeviceIPInformation(ref List<string> ipList)
        {
            asreader.GetDeviceIPInformation(ref ipList);
        }

        /// <summary>
        /// device connect
        /// </summary>
        /// <param name="comPort"></param>
        /// <returns></returns>
        public static UInt32 ConnectWithVcp(string comPort)
        {
            UInt32 ret = asreader.ConnectWithVCP(comPort);
            if (ret == 0) SetDelegate();
            return ret;
        }
        
        /// <summary>
         /// device connect(TCP)
         /// </summary>
         /// <param name="tcpIpAddress"></param>
         /// <param name="tcpPort"></param>
         /// <returns></returns>
        public static UInt32 ConnectWithTcp(string tcpIpAddress, string tcpPort)
        {
            UInt32 ret = asreader.ConnectWithTCP(tcpIpAddress, tcpPort);
            if (ret == 0) SetDelegate();
            return ret;
        }

        /// <summary>
        /// Device Disconnect
        /// </summary>
        public static UInt32 DisConnect() {
            return asreader.DisConnect();
        }

        public static UInt32 StartInventory(bool rssiEn, byte mtnu, byte mtime, ushort rc, bool ant1, bool ant2, bool ant3, bool ant4, bool ant5, bool ant6, bool ant7, bool ant8)
        {
            return asreader.StartInventory(rssiEn, mtnu, mtime, rc, ant1, ant2, ant3, ant4, ant5, ant6, ant7, ant8);
        }

        public static UInt32 WriteMemory(Types.MemBankType membank, UInt32 offset, UInt32 password, byte[] epc, byte[] ren)
        {
            return asreader.WriteMemory(membank, offset, password, epc, ren);
        }

        public static UInt32 ReadMemory(Types.MemBankType membank, UInt32 offset, UInt32 length, UInt32 password, byte[] epc)
        {
            return asreader.ReadMemory(membank, offset, length, password, epc);
        }

        public static UInt32 SetSelectMask(Types.MemBankType membank, Types.TargetType target, Types.ActionType action, UInt32 selOffset, byte[] epc)
        {
            return asreader.SetSelectMask(membank, target, action, selOffset, epc);
        }

        public static UInt32 LockMemory(AsReader.TagMask tagMask, AsReader.TagAction tagAction, UInt32 accessPwd, byte[] epc)
        {
            return asreader.LockMemory(tagMask, tagAction, accessPwd, epc);
        }

        public static UInt32 Kill(UInt32 killPwd, byte[] epc) {
            return asreader.Kill(killPwd, epc);
        }

        public static UInt32 SetSession(Types.SessionType session)
        {
            return asreader.SetSession(session);
        }

        public static UInt32 GetSession(ref Types.SessionType sessionType)
        {
            return asreader.GetSession(ref sessionType);
        }

        public static UInt32 StopInventory() {
            return asreader.StopInventory();
        }

        public static UInt32 SetTxPower(UInt32 power)
        {
            return asreader.SetTxPower(power);
        }

        public static UInt32 SetTxPower(uint txPowerAnt1, uint txPowerAnt2, uint txPowerAnt3, uint txPowerAnt4, uint txPowerAnt5, uint txPowerAnt6, uint txPowerAnt7, uint txPowerAnt8)
        {
            return asreader.SetTxPower(txPowerAnt1, txPowerAnt2, txPowerAnt3, txPowerAnt4, txPowerAnt5, txPowerAnt6, txPowerAnt7, txPowerAnt8);
        }

        public static UInt32 SetReadTime(uint time_ant1, uint time_ant2, uint time_ant3, uint time_ant4, uint time_ant5, uint time_ant6, uint time_ant7, uint time_ant8)
        {
            return asreader.SetReadTime(time_ant1, time_ant2, time_ant3, time_ant4, time_ant5, time_ant6, time_ant7, time_ant8);
        }

        public static UInt32 GetReadTime(ref uint time_ant1, ref uint time_ant2, ref uint time_ant3, ref uint time_ant4, ref uint time_ant5, ref uint time_ant6, ref uint time_ant7, ref uint time_ant8)
        {
            return asreader.GetReadTime(ref time_ant1, ref time_ant2, ref time_ant3, ref time_ant4, ref time_ant5, ref time_ant6, ref time_ant7, ref time_ant8);
        }

        public static UInt32 GetTxPower(ref UInt32 power)
        {
            return asreader.GetTxPower(ref power);
        }

        public static UInt32 SetAntiCollisionMode(Types.AntiCollisionMode anticollisionmode)
        {
            return asreader.SetAntiCollisionMode(anticollisionmode);
        }

        public static UInt32 GetAntiCollisionMode(ref Types.AntiCollisionMode antiCollision)
        {
            return asreader.GetAntiCollisionMode(ref antiCollision);
        }

        public static UInt32 SetChannel(uint channel)
        {
            return asreader.SetChannel(channel);
        }

        public static UInt32 GetChannel(ref uint channel)
        {
            return asreader.GetChannel(ref channel);
        }

        public static UInt32 SetQuery(Types.DRType dr, Types.MType m, Types.TRextType trext, Types.SelType sel, Types.SessionType session, Types.TargetABType target, Types.QType q)
        {
            return asreader.SetQuery(dr, m, trext, sel, session, target, q);
        }

        public static bool UpdateRegistry()
        {
            return asreader.UpdateRegistry();
        }

        public static UInt32 GetQuery(ref Types.DRType dr, ref Types.MType m, ref Types.TRextType trext, ref Types.SelType sel, ref Types.SessionType session, ref Types.TargetABType target, ref Types.QType q)
        {
            return asreader.GetQuery(ref dr, ref m, ref trext, ref sel, ref session, ref target, ref q);
        }

        public static UInt32 GetTxPower(ref uint txPowerAnt1, ref uint txPowerAnt2, ref uint txPowerAnt3, ref uint txPowerAnt4, ref uint txPowerAnt5, ref uint txPowerAnt6, ref uint txPowerAnt7, ref uint txPowerAnt8)
        {
            return asreader.GetTxPower(ref txPowerAnt1, ref txPowerAnt2, ref txPowerAnt3, ref txPowerAnt4, ref txPowerAnt5, ref txPowerAnt6, ref txPowerAnt7, ref txPowerAnt8);
        }

        public static UInt32 SetRegion(Types.RegionType region)
        {
            return asreader.SetRegion(region);
        }

        public static UInt32 GetRegion(ref Types.RegionType regionType)
        {
            return asreader.GetRegion(ref regionType);
        }

        public static void GetSdkVersion(ref string SdkVersion)
        {
            asreader.GetSdkVersion(ref SdkVersion);
        }
        public static bool SetStaticIP(string ip, string subnet, string gateway, string dns)
        {
            return asreader.SetStaticIP(ip, subnet, gateway, dns);
        }
        public static bool SetDHCP()
        {
            return asreader.SetDHCP();
        }
        
        public static uint SetIdelTime(uint idelTime)
        {
            return asreader.SetIdelTime(idelTime);
        }
        public static uint GetIdelTime(ref uint idelTime)
        {
            return asreader.GetIdelTime(ref idelTime);
        }

        public static bool UpdateLoadHex()
        {
            return asreader.UpdateLoadHex();
        }

        public static bool UpdateFirmware(string msg)
        {
            return asreader.UpdateFirmware(msg);
        }

        public static string GetFWVersion()
        {
            return asreader.GetFWVersion();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="delCallBackReadTagData"></param>
        /// <param name="delCallBackErrorString"></param>
        private static void SetDelegate()
        {
            AsReader.CallBackReadTagData delCallBackReadTagData = CallBackReadTagData;
            AsReader.CallBackErrorCode delCallBackErrorCode = CallBackErrorCode;
            AsReader.CallBackSuccessCode delCallBackSuccessCode = CallBackSuccessCode;
            asreader.SetDelegate(delCallBackReadTagData, delCallBackErrorCode, delCallBackSuccessCode);
        }

        public static void CallBackReadTagData(AsReader.InventoryResult tagcallbackdata)
        {
            if (callBackResultTagData != null)
            {
                callBackResultTagData(tagcallbackdata);
            }
        }

        public static void CallBackErrorCode(uint error)
        {
            if (callBackResultError != null)
            {
                callBackResultError(error);

            }
        }

        public static void CallBackSuccessCode(uint error)
        {
            if (callBackResultSuccess != null)
            {
                callBackResultSuccess(error);

            }
        }

        /// <summary>
        /// Q combox list
        /// </summary>
        public static DataTable getQList()
        {
            Array arrs = System.Enum.GetValues(typeof(Types.QType));    // 获取枚举的所有值
            DataTable dt = new DataTable();
            dt.Columns.Add("value", typeof(int));
            dt.Columns.Add("name", Type.GetType("System.String"));
            foreach (var arr in arrs)
            {
                string strText = Enum.Parse(typeof(Types.QType), arr.ToString()).ToString();
                DataRow aRow = dt.NewRow();
                aRow[0] = (int)arr;
                aRow[1] = strText;
                dt.Rows.Add(aRow);
            }
            return dt;
        }

        /// <summary>
        /// combox list
        /// </summary>
        public static DataTable getComboxList(Type type)
        {
            Array arrs = System.Enum.GetValues(type);    // 获取枚举的所有值
            DataTable dt = new DataTable();
            dt.Columns.Add("value", typeof(int));
            dt.Columns.Add("name", Type.GetType("System.String"));
            foreach (var arr in arrs)
            {
                string strText = Enum.Parse(type, arr.ToString()).ToString();
                DataRow aRow = dt.NewRow();
                aRow[0] = (int)arr;
                aRow[1] = strText;
                dt.Rows.Add(aRow);
            }
            return dt;
        }
        /// <summary>
        /// combox list
        /// </summary>
        public static string getMaxPowerByRegion(Types.RegionType regionType)
        {
            string maxPower = "";
            switch (regionType)
            {
                case Types.RegionType.REGION_JAPAN:
                    maxPower = "23";
                    break;
                case Types.RegionType.REGION_CHINA2:
                    maxPower = "25";
                    break;
                default:
                    maxPower = "27";
                    break;
            }
            return maxPower;
        }
    }
}
